using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace RusToEng
{
    public class DirectoryFile
    {
        /// <summary>
        /// Get files from path.
        /// </summary>
        /// <param name="path">root folder to traversal</param>
        /// <param name="files">store results</param>
        /// <param name="isAllInclude">indicate whether traversal subfolder</param>
        public static void GetFiles(string path, ref List<string> files, bool isAllInclude)
        {
            try
            {
                DirectoryInfo dir = new DirectoryInfo(path);
                FileInfo[] SubFiles = dir.GetFiles();

                foreach (FileInfo fileNext in SubFiles)
                {
                    string fileName = fileNext.ToString();
                    if (fileNext.Extension.ToLower() == ".txt"
                        || fileNext.Extension.ToLower() == ".mqh"
                        || fileNext.Extension.ToLower() == ".mq4")
                    {
                        string path_total = path + "\\" + fileName;
                        files.Add(path_total);
                    }
                }
                if (isAllInclude)
                {
                    FileSystemInfo[] dirs = dir.GetDirectories();
                    foreach (DirectoryInfo dirNext in dirs)
                    {
                        string nextPath = path + "\\" + dirNext.ToString();
                        GetFiles(nextPath, ref files, isAllInclude);
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
    }
}
